unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ScktComp,
  IniFiles;

type
  TForm1 = class(TForm)
    LockinSocket: TClientSocket;
    Button1: TButton;
    Memo1: TMemo;
    Button2: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    procedure GetNetData (S2Net : String; var Net2S : String);
    procedure DisplayDataInMemo (S2Display : String);
  public
    IniFile : TIniFile;
  end;

var
  Form1: TForm1;
  i : integer;

implementation

{$R *.dfm}
const   CRLF=#13#10;

procedure TForm1.FormCreate(Sender: TObject);
begin
  IniFile:=TInifile.Create(ExtractFilePath(Application.Exename)+'lockin.ini');
  LockinSocket.Address:=IniFile.ReadString('Connections','eLockIP','192.168.1.7');
  LockinSocket.Port:=IniFile.ReadInteger('Connections','eLockPort',80);

  //SaveSep:=DecimalSeparator;
  DecimalSeparator:='.';
end;

procedure TForm1.Button1Click(Sender: TObject);
var StoNet, NetToS : string;
begin
  StoNet:=IniFile.ReadString('Connections','eLockAuthString','')+CRLF+CRLF;
  GetNetData (StoNet, NettoS);
  DisplayDataInMemo (NetToS);
end;



procedure TForm1.GetNetData (S2Net : String; var Net2S : String);
const
  TimeOut=1000;
  BufLen=1000;
  BlockTimeOut = 1000;
var
  Buffer: array[0..Pred(BufLen)] of Byte;
  StrStream: TStringStream;
  WSockStream: TWinSocketStream;
  iRead : longint;
begin
  StrStream:=TStringStream.Create(S2Net);
  StrStream.Read(Buffer,Length(StrStream.DataString));
  WSockStream:=TWinSocketStream.Create(LockinSocket.Socket,TimeOut);
  LockinSocket.Open;
  WSockStream.Write(Buffer,Length(StrStream.DataString));

  StrStream.Size:=0;
  StrStream.Position:=0;
  repeat
    iRead:=0;
    if WSockStream.WaitForData(BlockTimeOut) then iRead:=WSockStream.Read(Buffer,BufLen);
    StrStream.Write(Buffer,iRead);
  until (iRead=0) or not LockinSocket.Active;

  LockinSocket.Close;
  WSockStream.Free;

  Net2S :=StrStream.DataString;
  StrStream.Free;
end;

procedure TForm1.DisplayDataInMemo (S2Display : String);
var S : String;
    i : integer;
begin
  Memo1.Lines.Clear;
  s:='';
  for i:=1 to length(S2Display) do begin
    if S2Display[i]=#10 then begin
      Memo1.Lines.Add(S);
      S:='';
    end else begin
      if S2Display[i]<>#13 then
        S:=S+S2Display[i];
    end;
  end;

end;

procedure TForm1.Button2Click(Sender: TObject);
var StoNet, NetToS, S : string;
begin
//'GET /cgi-bin/remote.cgi?'+CmdStr+' HTTP/1.0'+CRLF+CRLF);
  StoNet:='GET /data/lia.dat HTTP/1.0'+CRLF+CRLF;
  GetNetData (StoNet, NettoS);
  S:=Copy(NettoS, Pos(CRLF+CRLF,NettoS)+4,Length(NettoS)); // trim left side
  DisplayDataInMemo (S);

end;

function GetLockInData : double; export; cdecl;
begin
  result:=1.23;
  //inc(i);
end;


exports GetLockInData  name '_GetLockInData';

begin
  randomize;
  i:=0;
end.
