library eLockin;

{ Important note about DLL memory management: ShareMem must be the
  first unit in your library's USES clause AND your project's (select
  Project-View Source) USES clause if your DLL exports any procedures or
  functions that pass strings as parameters or function results. This
  applies to all strings passed to and from your DLL--even those that
  are nested in records and classes. ShareMem is the interface unit to
  the BORLNDMM.DLL shared memory manager, which must be deployed along
  with your DLL. To avoid using BORLNDMM.DLL, pass string information
  using PChar or ShortString parameters. }

uses
  SysUtils,
  Classes,
  Forms,
  form in 'form.pas' {Form1};

{$R *.res}

function GetLockInData (Channel : Integer) : double; export; cdecl;
begin
  Result:=Form1.GetDataLia(Channel) ;
end;
//////////////////////////////////////////////////////////////////
procedure SetLockInInpRange (data : double); export; cdecl;
var SIn : String;
begin
  SIn:='899_'+IntToStr(round(Data))+'_';
  Form1.SetNetData (SIn);
end;

procedure SetLockInCouple (data : double); export; cdecl;
var SIn : String;
begin
  SIn:='89D_'+IntToStr(round(Data))+'_';
  Form1.SetNetData (SIn);
end;

procedure SetLockInFilterTime (data : double); export; cdecl;
var SIn : String;
begin
  SIn:='895_'+IntToStr(round(Data))+'_';
  Form1.SetNetData (SIn);
end;
procedure SetLockInFilterSlope (data : double); export; cdecl;
var SIn : String;
begin
  SIn:='891_'+IntToStr(round(Data))+'_';
  Form1.SetNetData (SIn);
end;
//////////////////////////////
procedure SetLockInUac (data : double); export; cdecl;
var SIn : String;
begin
  SIn:='8D9_'+FloatToStrF(Data,ffFixed,5,4)+'_';
  Form1.SetNetData (SIn);
end;
procedure SetLockInFreq (data : double); export; cdecl;
var SIn : String;
begin
  Form1.Memo1.Lines.Add('fre');
  SIn:='8DD_'+FloatToStrF(Data,ffFixed,8,2)+'_';
  Form1.SetNetData (SIn);
end;
procedure SetLockInPhase (data : double); export; cdecl;
var SIn : String;
begin
  SIn:='8D5_'+FloatToStrF(Data,ffFixed,4,3)+'_';
  Form1.SetNetData (SIn);
end;
procedure SetLockInHarm (data : double); export; cdecl;
var SIn : String;
begin
  SIn:='8D1_'+IntToStr(round(Data))+'_';
  Form1.SetNetData (SIn);
end;

procedure SetLockInAuxOut (Channel : LongInt; data : double); export; cdecl;
var SIn : String;
begin
  SIn:='819_'+IntToStr(Channel)+'_5_'+FloatToStrF(Data, ffFixed,8,3)+'_';
  Form1.SetNetData (SIn);
end;

procedure Init (data : pChar); export; cdecl;
var S : String;
begin
  S:=STRING(data);
  Form1.Init(S);
end;


exports GetLockInData           name '_GetLockInData';
exports SetLockInInpRange       name '_SetLockInInpRange';
exports SetLockInCouple         name '_SetLockInCouple';
exports SetLockInFilterTime     name '_SetLockInFilterTime';
exports SetLockInFilterSlope    name '_SetLockInFilterSlope';
exports SetLockInUac            name '_SetLockInUac';
exports SetLockInFreq           name '_SetLockInFreq';
exports SetLockInPhase          name '_SetLockInPhase';
exports SetLockInHarm           name '_SetLockInHarm';
exports SetLockInAuxOut         name '_SetLockInAuxOut';

exports Init           name '_Init';

begin
  Application.Initialize;
  Application.CreateForm(TForm1, Form1);
  DecimalSeparator:='.';
end.
