unit form;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ScktComp,
  IniFiles, StdCtrls;

type
  TForm1 = class(TForm)
    lockinSocket: TClientSocket;
    Memo1: TMemo;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    Data : array [1..4] of real;
    procedure Init(IP : String);
    procedure GetNetData (S2Net : String; var Net2S : String);
    procedure SetNetData (S2Net : String);
    function GetDataLia (Channel : integer) : real;
    procedure DisplayDataInMemo (S2Display : String);
  end;

var
  Form1: TForm1;
  IniFile : TIniFile;


implementation

{$R *.dfm}

const CRLF = #13#10;

procedure TForm1.FormCreate(Sender: TObject);
begin
  //IniFile:=TInifile.Create('lockin.ini');
  Memo1.Clear;
end;

procedure TForm1.GetNetData (S2Net : String; var Net2S : String);
const
  TimeOut=1000;
  BufLen=1000;
  BlockTimeOut = 1000;
var
  Buffer: array[0..Pred(BufLen)] of Byte;
  StrStream: TStringStream;
  WSockStream: TWinSocketStream;
  iRead : longint;
begin
  StrStream:=TStringStream.Create(S2Net);
  StrStream.Read(Buffer,Length(StrStream.DataString));
  WSockStream:=TWinSocketStream.Create(Form1.LockinSocket.Socket,TimeOut);
  Form1.LockinSocket.Open;
  WSockStream.Write(Buffer,Length(StrStream.DataString));

  StrStream.Size:=0;
  StrStream.Position:=0;
  repeat
    iRead:=0;
    if WSockStream.WaitForData(BlockTimeOut) then iRead:=WSockStream.Read(Buffer,BufLen);
    StrStream.Write(Buffer,iRead);
  until (iRead=0) or not Form1.LockinSocket.Active;

  Form1.LockinSocket.Close;
  WSockStream.Free;

  Net2S :=StrStream.DataString;
  StrStream.Free;
end;

procedure TForm1.SetNetData (S2Net : String);
var StoNet, NetToS : string;
begin
  StoNet:='GET /cgi-bin/remote.cgi?'+S2Net+' HTTP/1.0'+CRLF+CRLF;
  GetNetData (StoNet, NettoS);
end;

function TForm1.GetDataLia (Channel : integer) : real;
var StoNet, NetToS, S : string;
    Index, i : integer;
begin
  Memo1.Lines.Add('GetData'+IntToStr(Channel));
  if Channel<1 then Channel:=1;
  if Channel>4 then Channel:=4;

  if Channel=1 then begin
    StoNet:='GET /data/lia.dat HTTP/1.0'+CRLF+CRLF;
    DisplayDataInMemo(StoNet);
    GetNetData (StoNet, NettoS);
    DisplayDataInMemo(s);
    S:=Copy(NettoS, Pos(CRLF+CRLF,NettoS)+4,Length(NettoS)); // trim left side
    for i:=1 to 4 do begin
      Index:=Pos(#13,S);
      if Index<2 then break;
      Data[i]:=StrToFloat(Copy(S,1,Index-1));
      S:=Copy(S,Index+2, length(S));
      Memo1.Lines.Add('ok '+IntToStr(i)+S+'#');
    end;

  end;
  Memo1.Lines.Add('GetDataOK');

  Result:=Data[Channel];
end;

procedure TForm1.DisplayDataInMemo (S2Display : String);
var S : String;
    i : integer;
begin
  Memo1.Lines.Clear;
  s:='';
  for i:=1 to length(S2Display) do begin
    if S2Display[i]=#10 then begin
      Memo1.Lines.Add(S);
      S:='';
    end else begin
      if S2Display[i]<>#13 then
        S:=S+S2Display[i];
    end;
  end;

end;

procedure TForm1.Init(IP : String);
var StoNet, S : String;
begin
  LockinSocket.Address:=IP;
  //IniFile.ReadString('Connections','eLockIP','192.168.1.7');
  //LockinSocket.Port:=IniFile.ReadInteger('Connections','eLockPort',80);

  //StoNet:='GET /cgi-bin/lockin.cgi?';
  //  SToNet:=SToNet+IniFile.ReadString('Connections','eLockAuthString','')+CRLF+CRLF;
  //  SToNet:=SToNet+' HTTP/1.0'+CRLF+CRLF;
  StoNet:='GET /cgi-bin/login.cgi?username=long&password=nga HTTP/1.0'+CRLF+CRLF;
  GetNetData (StoNet, S);
  DisplayDataInMemo (S);
end;


begin

end.
