unit Auth;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ScktComp;

type
  TAuthForm = class(TForm)
    UserEdit: TEdit;
    PwdEdit: TEdit;
    IPEdit: TEdit;
    ConnectButton: TButton;
    UserLabel: TLabel;
    PwdLabel: TLabel;
    IPLabel: TLabel;
    AutoLoginCheckBox: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure ConnectButtonClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
  public
  end;

var
  AuthForm: TAuthForm;

implementation

uses LockInMain;

{$R *.dfm}

procedure TAuthForm.FormCreate(Sender: TObject);
{
*Disable MainForm
*Load parameters from ini-file
*Save timer status
}
begin
  with MainForm do begin
    UserEdit.Text:=LockInIni.ReadString('LockIn','User','User');
    PwdEdit.Text:=LockInIni.ReadString('LockIn','Password','Password');
    IPEdit.Text:=LockInIni.ReadString('LockIn','IP','127.0.0.1');
    AutoLoginCheckBox.Checked:=LockInIni.ReadBool('GUI','AutoLogin',False);
  end;

//  if LockInIni.ReadBool('GUI','AutoLogin',False)=True then
//    ConnectButtonClick(MainForm);
end;

procedure TAuthForm.ConnectButtonClick(Sender: TObject);
var S : String;
    OldCursor : TCursor;
{
*Set new IP address
*Send login request
*Process response from LockIn, check for 'no_authentication'
*Close form if logged in
}
begin
  if ConnectButton.Caption='Connect' then  begin
    MainForm.ClientSocket.Address:=IPEdit.Text;

    // in case     MainForm.HandleConnection is not OK
    //Left:=MainForm.Left+MainForm.Width div 2- 285;
    //Top:=MainForm.Top+MainForm.Height div 2- 70;
    //Visible:=true;

    S:='/cgi-bin/login.cgi?username='+UserEdit.Text+'&password='+PwdEdit.Text;
    OldCursor := Screen.Cursor;
    Screen.Cursor:=crHourGlass;
    Application.ProcessMessages;
    try
      MainForm.HandleConnection(S);
    except
      Screen.Cursor:=OldCursor;

      //MainForm.ClientSocket.Free;
      ShowMessage('No Server found at this IP Adresse!');
      exit;
    end;
    Screen.Cursor:=OldCursor;

    if Pos('no_authentication', GlobalVar.LIResponse)=0 then begin
      // everything is OK
      if MainForm.IsConnected then begin
        MainForm.RefreshTimer.Enabled:=Enabled;
        ConnectButton.Caption:='Stop';
      end;

      LockInIni.WriteString('LockIn','User',UserEdit.Text);
      LockInIni.WriteString('LockIn','Password',PwdEdit.Text);
      LockInIni.WriteString('LockIn','IP',IPEdit.Text);
      LockInIni.WriteBool('GUI','AutoLogin',AutoLoginCheckBox.Checked);
      MainForm.Caption:='eLockIn remote control for '+UserEdit.Text+'@'+
                         IPEdit.Text;
      Close;
    end else
      ShowMessage('Login failed!'#13#10'User or password might be wrong.');

  end else
  begin
    ConnectButton.Caption:='Connect';
    MainForm.Caption:='eLockIn Remote';
    //MainForm.ClientSocket.Close;
  end;
end;

procedure TAuthForm.FormShow(Sender: TObject);
begin
  Left:=MainForm.Left+MainForm.Width div 2- 285;
  Top:=MainForm.Top+MainForm.Height div 2- 70;
end;

end.
