unit LockInMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, IniFiles, ScktComp, StdCtrls, Buttons, ExtCtrls, Jpeg;

type
  TGlobalVar = record
    LIAddress: String;
    LIKeys: String;
    LIResponse: String;
  end;

type
  TMainForm = class(TForm)
    MainMenu: TMainMenu;
    LockIn: TMenuItem;
    Authenticate: TMenuItem;
    ClientSocket: TClientSocket;
    KnobPopupMenu: TPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    Options: TMenuItem;
    RefreshTimer: TTimer;
    RefreshScreen: TMenuItem;
    ChannelLabel1: TLabel;
    ChannelLabel2: TLabel;
    ChannelLabel3: TLabel;
    ChannelLabel4: TLabel;
    AutoRefresh: TMenuItem;
    RefreshChannels: TMenuItem;
    LockInSpeedButton: TSpeedButton;
    SetupSpeedButton: TSpeedButton;
    MeasureSpeedButton: TSpeedButton;
    ScopeSpeedButton: TSpeedButton;
    SpectraSpeedButton: TSpeedButton;
    SpeedButton1: TSpeedButton;
    BackSpeedButton: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton2: TSpeedButton;
    UpSpeedButton: TSpeedButton;
    DownSpeedButton: TSpeedButton;
    RightSpeedButton: TSpeedButton;
    LeftSpeedButton: TSpeedButton;
    KnobSpeedButton: TSpeedButton;
    RefreshTimeLabel: TLabel;
    ValueEdit: TEdit;
    SendButton: TButton;
    TimeOut: TTimer;
    View1: TMenuItem;
    RefreshTime1: TMenuItem;
    SendCommand1: TMenuItem;
    File1: TMenuItem;
    Save1: TMenuItem;
    Screeenjpg1: TMenuItem;
    Specrtaasdat1: TMenuItem;
    Oszasdat1: TMenuItem;
    SaveDialog1: TSaveDialog;
    N3: TMenuItem;
    Exit1: TMenuItem;
    estSpeed1: TMenuItem;
    LogData1: TMenuItem;
    About1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure AuthenticateClick(Sender: TObject);
    procedure KnobPopupClick(Sender: TObject);
    function SendKey(Key: Integer): Boolean;
    procedure SpeedButtonClick(Sender: TObject);
    procedure ClientSocketConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocketRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure ScreenRefreshTimerEvent(Sender: TObject);
    procedure TestSpeedClick(Sender: TObject);
    procedure AutoRefreshScreenClick(Sender: TObject);
    procedure RefreshScreenClick(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    //procedure HandleConnection(OnConnect,OnRead: TSocketNotifyEvent);
    procedure HandleConnection2(Cmd : String);
    procedure HandleConnection(Cmd : String);
    procedure ChannelRefreshTimerEvent(Sender: TObject);
    procedure AutoRefreshClick(Sender: TObject);
    procedure RefreshChannelsClick(Sender: TObject);
    procedure ClientSocketError(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure ValueEditKeyPress(Sender: TObject; var Key: Char);
    procedure SendButtonClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure TimeOutTimer(Sender: TObject);
    procedure RefreshTime1Click(Sender: TObject);
    procedure SendCommand1Click(Sender: TObject);
    procedure Screeenjpg1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure UpdateMenuItems(Sender: TObject);
    procedure Specrtaasdat1Click(Sender: TObject);
    procedure Oszasdat1Click(Sender: TObject);
    procedure LogData1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
  private
    { Private declarations }
    BarBMP, BackBMP: TBitmap;
    KeyLock : boolean; //F
    JPEGStream: TStringStream;
    JPEGScreen: TJPEGImage;
    CountDown : integer;
    CmdString : String;
  public
    IsConnected : boolean;
    DataDir : String; // either '' or '/data'
  end;

const
  CRLF=#13#10;

var
  MainForm: TMainForm;
  GlobalVar: TGlobalVar;
  LockInIni: TIniFile;

implementation

uses Auth, SpeedTest, AutoRefresh, Log, About;

{$R *.dfm}
{$R MyRes.res}

procedure TMainForm.FormCreate(Sender: TObject);
{
*Opens ini-file, reads IP address
*Loads bitmaps for MainForm
}
begin
  KeyLock:=false; //F

  MainForm.DoubleBuffered:=True;
  LockInIni:=TIniFile.Create('.\LockIn.ini');

  Top:=LockInIni.ReadInteger('MainForm','FormTop',20);
  if Top>Screen.DesktopHeight then Top:=Screen.DesktopHeight-20;
  Left:=LockInIni.ReadInteger('MainForm','FormLeft',20);
  if Left>Screen.DesktopWidth then Left:=Screen.DesktopWidth-20;


  ClientSocket.Address:=LockInIni.ReadString('LockIn','IP','127.0.0.1');
  ClientSocket.OnConnect:=ClientSocketConnect;
  ClientSocket.OnRead:=ClientSocketRead;

  BarBMP:=TBitmap.Create;
  BarBMP.LoadFromResourceName(HInstance,'Bar');
  BackBMP:=TBitmap.Create;
  BackBMP.LoadFromResourceName(HInstance,'Back');

  JPEGScreen:=TJPEGImage.Create;
  JPEGStream:=TStringStream.Create('');

  ChannelLabel1.Caption:='';
  ChannelLabel2.Caption:='';
  ChannelLabel3.Caption:='';
  ChannelLabel4.Caption:='';

  Screen.OnActiveFormChange := UpdateMenuItems;   // not used

  // directory in elockin has chanched so DataDir is '' or /data
  DataDir:=LockInIni.ReadString('LockIn','DataDir','');// new May 09

  //AuthForm:=TAuthForm.Create(MainForm);
end;

procedure TMainForm.AuthenticateClick(Sender: TObject);
begin
  AuthForm.Show;
end;

procedure TMainForm.KnobPopupClick(Sender: TObject);
// Switch knob appearance
begin
  with Sender as TMenuItem do Checked:=not Checked;
  if N1.Checked then
  begin
    //KnobSpeedButton.Glyph.LoadFromFile('.\Knob+.bmp');
    KnobSpeedButton.Glyph.LoadFromResourceName(HInstance,'Knob+');
    KnobSpeedButton.Tag:=43;
  end else if N2.Checked then
  begin
    //KnobSpeedButton.Glyph.LoadFromFile('.\Knob-.bmp');
    KnobSpeedButton.Glyph.LoadFromResourceName(HInstance,'Knob-');
    KnobSpeedButton.Tag:=45;
  end;
end;

function TMainForm.SendKey(Key: Integer): Boolean;
{
*Sends keycode to remote.cgi
*Returns 'false' if not logged in
*Polls remote.cgi while it returns 'busy'
}
var S : String;
begin
  //GlobalVar.LIKeys:=GlobalVar.LIKeys+Char(Key);
  Result:=False; // default
  if KeyLock then begin//F
    if Char(Key)<>'S' then
      GlobalVar.LIKeys:=GlobalVar.LIKeys+Char(Key);
  end else begin
    KeyLock:=true;

    S:=GlobalVar.LIKeys+Char(Key);
    GlobalVar.LIKeys:='';
    HandleConnection('/cgi-bin/remote.cgi?'+S);
    if Pos('no_authentication',GlobalVar.LIResponse)>0 then  begin
      ShowMessage('Not logged in!');
    end else begin
      Result:=True;
      repeat
        sleep(100);
        HandleConnection('/cgi-bin/remote.cgi?');
      until Pos('busy',GlobalVar.LIResponse)=0;
    end;
    KeyLock:=false;
  end;
end;

procedure TMainForm.SpeedButtonClick(Sender: TObject);
{
*OnClick procedure for all buttons
}
begin
  with Sender as TSpeedButton do SendKey(Tag);
end;

procedure TMainForm.ClientSocketConnect(Sender: TObject;
  Socket: TCustomWinSocket);
{ *OnConnect procedure }
begin
  IsConnected := true;
  Socket.SendText('GET '+CmdString+' HTTP/1.0'+CRLF+CRLF);
end;

procedure TMainForm.ClientSocketRead(Sender: TObject;
  Socket: TCustomWinSocket);
// *OnRead procedure, GlobalVar.LIResponse contains response from LockIn
begin
  GlobalVar.LIResponse:=GlobalVar.LIResponse+Socket.ReceiveText;
end;

procedure TMainForm.ScreenRefreshTimerEvent(Sender: TObject);
{
*Retrieves new screen shot of the LockIn's display
*Sends 'S' first to dump new screen shot
*Cuts JPEG part from server response, writes it into StringStream (JPEGStream)
*JPEGScreen (instance of TJPEGImage) loads image from JPEGStream
*Draws JPEGScreen to Canvas of MainForm
}
var
  t: Cardinal;
begin
//  RefreshTimer.Enabled:=False;

  t:=GetTickCount(); // to det. time
  try
    if SendKey(ord('S'))=True then begin// S -> eLockin to save screen
      HandleConnection('/screen.jpg');
      with GlobalVar do begin
        JPEGStream.Position:=0;
        JPEGStream.WriteString(Copy(LIResponse,
          Pos(CRLF+CRLF,LIResponse)+4,Length(LIResponse)));
          {cut JPEG part from response}
        JPEGStream.Position:=0;

        LIResponse:=Copy(LIResponse,1,Pos(CRLF+CRLF,LIResponse)-1);
          {check if response contains JPEG}
        if (Pos('image/jpeg',LIResponse)>0) then
        try
          JPEGScreen.LoadFromStream(JPEGStream);            {open JPEG image}
          JPEGScreen.Scale:= jsHalf;
          MainForm.Canvas.StretchDraw(Rect(50,77,50+320,311),JPEGScreen);

          Screeenjpg1.Enabled:=true; // enable Save as jpg
          RefreshTimeLabel.Caption:=IntToStr(GetTickCount()-t)+' ms'
        except
        end;// else
         // ShowMessage('Screen could not be refreshed. Please try again.');
      end;
    end;//F else RefreshTimer.Enabled:=False;
  finally
  end;
end;

procedure TMainForm.TestSpeedClick(Sender: TObject);
begin
  SpeedTestForm:=TSpeedTestForm.Create(MainForm);
end;

procedure TMainForm.AutoRefreshScreenClick(Sender: TObject);
begin
  AutoRefreshForm.Show;//:=TAutoRefreshForm.Create(MainForm);
end;

procedure TMainForm.RefreshScreenClick(Sender: TObject);
begin
  if AutoRefreshForm<>nil then // check that is there
   AutoRefreshForm.RadioButton3.Checked:=true;  // AutoRefresh = "off"
  RefreshTimer.Enabled:=False;

  ScreenRefreshTimerEvent(Sender);
end;

procedure TMainForm.FormPaint(Sender: TObject);
begin
  MainForm.Canvas.Draw(382,314,BackBMP);
  MainForm.Canvas.Draw(420,0,BarBMP);
  MainForm.Canvas.Rectangle(50,77,370,311);
end;
////////////////////////////////////////////////////////////////
procedure TMainForm.HandleConnection(Cmd : String);
const BlockTimeOut=1000;
      BufLen= 1024*4;
var
  WSockStream : TWinSocketStream;
  StrStream : TStringStream;
  Buffer : array[0..BufLen-1] of Byte;
  iRead : Integer;
begin
//  StrStream:=TStringStream.Create('GET '+Cmd+' HTTP/1.0'+CRLF+CRLF);
  StrStream:=TStringStream.Create('');
//  StrStream.Read(Buffer,Length(StrStream.DataString));
  ClientSocket.ClientType:=ctBlocking;
  WSockStream:=TWinSocketStream.Create(ClientSocket.Socket,BlockTimeOut);

  CmdString:=Cmd;
  ClientSocket.Open;
//  WSockStream.Write(Buffer,Length(StrStream.DataString));

  StrStream.Size:=0;
  repeat
    iRead:=0;
    if WSockStream.WaitForData(BlockTimeOut) then  begin
      iRead:=WSockStream.Read(Buffer,BufLen);
      StrStream.Write(Buffer,iRead);
    end;
  until(iRead=0);
  ClientSocket.Close;

  GlobalVar.LIResponse:=StrStream.DataString;
  StrStream.Free;
end;




procedure TMainForm.HandleConnection2(Cmd : String);
{
*Procedure which handles all connections to the LockIn
*Takes OnConnect and OnRead events as arguments
*GlobalVar.LIResponse contains server response afterwards
}
begin
  //F SetLength(GlobalVar.LIResponse,0);
  //F ClientSocket.OnConnect:=OnConnect;
  //F ClientSocket.OnRead:=OnRead;

  //wait while connection is still open
  CountDown:=10;
  while (ClientSocket.Socket.Connected) and (CountDown>0) do
    Application.ProcessMessages;
  if CountDown=0 then begin
    RefreshTimer.Enabled:=false;
    MessageDlg('eLockin is slow!',mtInformation, [mbOk], 0);
    System.exit;
  end;

  //SetLength(GlobalVar.LIResponse,0);
  GlobalVar.LIResponse:='';

  IsConnected := false;
  try
    CmdString:=Cmd;
    ClientSocket.Open();
  except
    RefreshTimer.Enabled:=false;
    ShowMessage('Could not connect to eLockIn!');
    System.Exit;
  end;

  //wait until connection is open
  //while not ClientSocket.Socket.Connected do
  CountDown:=10;
  while (not IsConnected) and (CountDown>0)  do
    Application.ProcessMessages;
  if CountDown=0 then begin
    RefreshTimer.Enabled:=false;
    MessageDlg('eLockin is not responding!',mtInformation, [mbOk], 0);
  end;

  //wait while transfer is in progress}
  CountDown:=10;
  while (ClientSocket.Socket.Connected) and (CountDown>0) do
    Application.ProcessMessages;
  if CountDown=0 then begin
    RefreshTimer.Enabled:=false;
    MessageDlg('eLockin is still working!',mtInformation, [mbOk], 0);
  end;

end;

procedure TMainForm.ChannelRefreshTimerEvent(Sender: TObject);
{
*Retrieves new values for current channels
*refresh.cgi's response is HTML -> values must be extracted first
}
var
i,j: Integer;
ChUnit,ChValue: String;
     t : Cardinal;
     LIResp : String;
begin
  t:=GetTickCount(); // to det. time
  HandleConnection('/cgi-bin/refresh.cgi');
  RefreshTimeLabel.Caption:=IntToStr(GetTickCount()-t)+' ms';

  LIResp:=GlobalVar.LIResponse;
  if Pos('no_authentication',LIResp)=0 then begin
    Delete(LIResp,1,Pos('<tbody>',LIResp));
    for i:=1 to 8 do begin
      Delete(LIResp,1,Pos('<h1',LIResp));
      Delete(LIResp,1,Pos('>',LIResp));
      if Odd(i) then
        ChUnit:=Copy(LIResp,1,Pos('<',LIResp)-1)+': '
      else begin
        ChValue:=ChValue+Copy(LIResp,1,Pos('<',LIResp)-1);
        if Length(ChValue)<9 then
          for j:=1 to 9-Length(ChValue) do ChValue:=' '+ChValue;
      end;

      if i=2 then ChannelLabel1.Caption:=ChUnit+ChValue;
      if i=4 then ChannelLabel2.Caption:=ChUnit+ChValue;
      if i=6 then ChannelLabel3.Caption:=ChUnit+ChValue;
      if i=8 then ChannelLabel4.Caption:=ChUnit+ChValue;
      if Odd(i)=False then begin ChUnit:=''; ChValue:=''; end;
    end;
  end else
  begin
    ShowMessage('Not logged in!');
    RefreshTimer.Enabled:=False;
  end;

  MainForm.Repaint;
end;

procedure TMainForm.AutoRefreshClick(Sender: TObject);
begin
  AutoRefreshForm.Show;
  //AutoRefreshForm:=TAutoRefreshForm.Create(MainForm);
end;

procedure TMainForm.RefreshChannelsClick(Sender: TObject);
begin
  RefreshTimer.Enabled:=False;
  ChannelRefreshTimerEvent(Sender);
  if AutoRefreshForm<>nil then // check that is there
   AutoRefreshForm.RadioButton3.Checked:=true;  // AutoRefresh = "off"

end;

procedure TMainForm.ClientSocketError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
{
*On Error procedure
*Exit to avoid freeze
}
begin
  if AutoRefreshForm<>nil then begin
    AutoRefreshForm.RadioButton3.Checked:=true;
    AutoRefreshForm.RadioButton3.Update;
  end else
    RefreshTimer.Enabled:=false;

  if ErrorEvent=eeGeneral then
    ShowMessage('Socket raised General-Exception!');
  if ErrorEvent=eeConnect then
    ShowMessage('Could not co1nnect to LockIn!');
  if ErrorEvent=eeSend then
    ShowMessage('Socket raised Send-Exception!');
  if ErrorEvent=eeReceive then
    ShowMessage('Socket raised Receive-Exception!');
  if ErrorEvent=eeDisconnect then
    ShowMessage('Socket raised Disconnect-Exception!');
  if ErrorEvent=eeAccept then
    ShowMessage('Socket raised Accept-Exception!');

  ErrorCode:=0; // just go on
end;

procedure TMainForm.ValueEditKeyPress(Sender: TObject; var Key: Char);
begin
  if Key=',' then Key:='.';
  if not (Key in ['0'..'9',#8,#13,'.']) then Key:=#0;
  if (Key='.') and (Pos('.',ValueEdit.Text)>0) then Key:=#0;
  if Key=#13 then SendButtonClick(SendButton) else ValueEdit.Color:=clSilver;
end;

procedure TMainForm.SendButtonClick(Sender: TObject);
var S : String;
begin
  if Length(ValueEdit.Text)>0 then  begin
    ValueEdit.Color:=clWhite;
    //S:='_'+ValueEdit.Text+'_';
    S:=ValueEdit.Text;
    HandleConnection('/cgi-bin/remote.cgi?'+S);
    if Pos('no_authentication',GlobalVar.LIResponse)>0 then
      ShowMessage('Not logged in!');
  end else ValueEdit.Color:=clSilver;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  JPEGStream.Free;
  JPEGScreen.Free;

  LockInIni.WriteInteger('MainForm','FormTop',Top);
  LockInIni.WriteInteger('MainForm','FormLeft',Left);
end;

procedure TMainForm.TimeOutTimer(Sender: TObject);
begin
  if CountDown>0 then dec(CountDown);

  TimeOut.Enabled:=false;
end;

procedure TMainForm.RefreshTime1Click(Sender: TObject);
begin
  RefreshTime1.Checked:= not RefreshTime1.Checked;
  RefreshTimeLabel.Visible:=RefreshTime1.Checked;
end;

procedure TMainForm.SendCommand1Click(Sender: TObject);
begin
  SendCommand1.Checked:= not SendCommand1.Checked;
  ValueEdit.Visible:=SendCommand1.Checked;
  SendButton.Visible:=SendCommand1.Checked;
end;

procedure TMainForm.Screeenjpg1Click(Sender: TObject);
begin
  SaveDialog1.Filter:='Picture (*.jpg)|*.JPG';;
  SaveDialog1.DefaultExt:='*.jpg';
  if SaveDialog1.Execute then begin
    JPEGScreen.Scale:= jsFullSize;
    JPEGScreen.SaveToFile(SaveDialog1.FileName);
    Application.ProcessMessages;
    // refresh Screen
    JPEGScreen.Scale:= jsHalf;
    Canvas.StretchDraw(Rect(50,77,50+320,311),JPEGScreen);
    Update;
  end;
end;

procedure TMainForm.Exit1Click(Sender: TObject);
begin
  Application.ProcessMessages;
  Application.Terminate;
end;

procedure TMainForm.UpdateMenuItems(Sender: TObject);
begin
//
end;

procedure TMainForm.Specrtaasdat1Click(Sender: TObject);
var S : String;
    f : TextFile;
begin
  HandleConnection(MainForm.DataDir+'/spectra.dat');
  S:=GlobalVar.LIResponse;
  S:=Copy(S, Pos(CRLF+CRLF,S)+4,Length(S));
  if pos('was not found',S)>0 then begin
    MessageDlg('No spectra found on the Server!'+#13+'          Save aborded.',
                mtInformation,[mbOk], 0);
    exit;
  end;

  SaveDialog1.Filter:='Data (*.dat)|*.dat';;
  SaveDialog1.DefaultExt:='*.dat';
  if SaveDialog1.Execute then begin
    AssignFile(f,SaveDialog1.FileName);
    Rewrite(f);
    Write(f, S);
    CloseFile(f);
  end;


end;

procedure TMainForm.Oszasdat1Click(Sender: TObject);
var S : String;
    f : TextFile;
    Answer : word;
begin
  Answer:=MessageDlg('Save data before retrieve?',
              mtInformation,[mbYes, mbNo, mbCancel], 0);

  if Answer=mrCancel then exit;
  if Answer=mrYes then begin
    HandleConnection('/cgi-bin/remote.cgi?'+'419_2_5');
    S:=GlobalVar.LIResponse;
    sleep(1000);
  end;

  HandleConnection(MainForm.DataDir+'/osc.dat');
  S:=GlobalVar.LIResponse;
  S:=Copy(S, Pos(CRLF+CRLF,S)+4,Length(S));
  if pos('was not found',S)>0 then begin
    MessageDlg('No Data found on the Server!'+#13+'          Save aborded.',
                mtInformation,[mbOk], 0);
    exit;
  end;


  SaveDialog1.Filter:='Data (*.dat)|*.dat';
  SaveDialog1.DefaultExt:='*.dat';
  if SaveDialog1.Execute then begin
    AssignFile(f,SaveDialog1.FileName);
    Rewrite(f);
    Write(f, S);
    CloseFile(f);
  end;
end;

procedure TMainForm.LogData1Click(Sender: TObject);
begin
  Enabled:=false;

  // Autorefresh off
  AutoRefreshForm.RadioButton3.Checked:=true;
  AutoRefreshForm.RadioButton3.Update;

  LogForm.Visible:=true;
end;

procedure TMainForm.About1Click(Sender: TObject);
begin
  AboutBox.Show;
end;

end.
