unit Log;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TLogForm = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    Timer1: TTimer;
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Edit2: TEdit;
    Label3: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure EditKeyPress(Sender: TObject; var Key: Char);
    procedure Edit1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Edit2KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Timer1Timer(Sender: TObject);
  private
    DataPoints : integer;
    ActDataPoints : integer;
    TimeZero : cardinal;
  public
    { Public declarations }
  end;

var
  LogForm: TLogForm;

implementation

uses LockInMain;

{$R *.dfm}

procedure TLogForm.Button1Click(Sender: TObject);
begin
  if Button1.Caption='Start' then begin
    Memo1.Clear;
    Button1.Caption:='Stop';
    ActDataPoints:=0;
    Timer1.Enabled:=true;
    TimeZero:=GetTickCount();
  end else begin
    Button1.Caption:='Start';
  end;
end;

procedure TLogForm.FormCreate(Sender: TObject);
var Key : word;
begin
  Top:=LockInIni.ReadInteger('LogForm','FormTop',20);
  if Top>Screen.DesktopHeight then Top:=Screen.DesktopHeight-20;
  Left:=LockInIni.ReadInteger('LogForm','FormLeft',20);
  if Left>Screen.DesktopWidth then Left:=Screen.DesktopWidth-20;

  Edit1.Text:=LockInIni.ReadString('LogForm','Intervall','1');
  Edit2.Text:=LockInIni.ReadString('LogForm','Datapoints','64');

  Memo1.Clear;

  Key:=13;
  Edit1KeyUp(Edit1, Key, []);
  Key:=13;
  Edit2KeyUp(Edit2, Key, []);
end;

procedure TLogForm.FormDestroy(Sender: TObject);
begin
  LockInIni.WriteInteger('LogForm','FormTop',Top);
  LockInIni.WriteInteger('LogForm','FormLeft',Left);
end;

procedure TLogForm.EditKeyPress(Sender: TObject; var Key: Char);
begin
  if key=#13 then Key:=#0;
end;

procedure TLogForm.Edit1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var t : real;
begin
  with Sender as TEdit do begin
    Color:=clSilver;
    if Key=13 then begin
      try
        t:=StrToFloat(Text);
        Color:=clWhite;
        Timer1.Interval:=round(1000*t);
        LockInIni.WriteString('LogForm','Intervall',Text);
      except
        Color:=clRed;
      end;
    end;
  end;
end;

procedure TLogForm.Edit2KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  with Sender as TEdit do begin
    Color:=clSilver;
    if Key=13 then begin
      try
        Datapoints:=StrToInt(Text);
        Color:=clWhite;
        LockInIni.WriteString('LogForm','Datapoints',Text);
      except
        Color:=clRed;
      end;
    end;
  end;
end;

procedure TLogForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  MainForm.Enabled:=True;

  Timer1.Enabled:=false;
  Button1.Caption:='Start';
end;

procedure TLogForm.Timer1Timer(Sender: TObject);
var S : String;
    i : integer;
    t : cardinal;
begin
  if (ActDataPoints>=DataPoints) or (Button1.Caption='Start') then begin
    Timer1.Enabled:=false;
    Button1.Caption:='Start';
    exit;
  end else begin
    inc(ActDatapoints);
  end;

  MainForm.HandleConnection(MainForm.DataDir+'/lia.dat');
  //MainForm.HandleConnection('/lia.dat');
  S:=GlobalVar.LIResponse;
  S:=Copy(S, Pos(CRLF+CRLF,S)+4,Length(S));
  for i:=1 to 3 do begin  // handle 0d0a
    if pos(#13,S)>0 then s[pos(#13,S)]:=#9;
    if pos(#10,S)>0 then s[pos(#10,S)]:=' ';
  end;
  if pos(#13,S)>0 then s[pos(#13,S)]:=' ';
  if pos(#10,S)>0 then s[pos(#10,S)]:=' ';

  t:=GetTickCount(); // to det. time


  Memo1.Lines.Add(InttoStr(ActDatapoints)+#9+FloatToStrF((t-TimeZero)/1000,ffGeneral,6,3)+#9+S);
end;

end.
